// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkID=397705
// To debug code on page load in Ripple or on Android devices/emulators: launch your app, set breakpoints, 
// and then run "window.location.reload()" in the JavaScript Console.
var SmartBusiness;
// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkID=397705
// To debug code on page load in Ripple or on Android devices/emulators: launch your app, set breakpoints, 
// and then run "window.location.reload()" in the JavaScript Console.
(function (SmartBusiness) {
    var App;
    (function (App) {
        "use strict";
        var Application;
        (function (Application) {
            function initialize() {
                document.addEventListener('deviceready', onDeviceReady, false);
            }
            Application.initialize = initialize;
            function onDeviceReady() {
                // Handle the Cordova pause and resume events
                document.addEventListener('pause', onPause, false);
                document.addEventListener('resume', onResume, false);
                // TODO: Cordova has been loaded. Perform any initialization that requires Cordova here.
            }
            function onPause() {
                // TODO: This application has been suspended. Save application state here.
            }
            function onResume() {
                // TODO: This application has been reactivated. Restore application state here.
            }
        })(Application = App.Application || (App.Application = {}));
        window.onload = function () {
            Application.initialize();
        };
    })(App = SmartBusiness.App || (SmartBusiness.App = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    'use strict';
    var Config = (function () {
        function Config() {
            this.hostUrl = "https://www.takefoodaway.com";
            this.shopId = "1C8E7695-A5C3-4369-9F65-FD790CD4B37E";
            this.appId = "27055388-8C43-45C8-88DF-34A08B012B87";
            this.apiKey = "nFibaz9x5eflu508LOeLNGxZpxVOJheQ70h";
        }
        return Config;
    }());
    SmartBusiness.Config = Config;
})(SmartBusiness || (SmartBusiness = {}));
(function () {
    "use strict";
    angular.module("smartBusiness", ['ionic', 'ionic.utils', 'ui.mask', 'ionic-timepicker'])
        .run(ionicPlatform)
        .constant("smartBusinessConfig", new SmartBusiness.Config())
        .config(config);
    ionicPlatform.$inject = ['$ionicPlatform'];
    function ionicPlatform($ionicPlatform) {
        $ionicPlatform.ready(function () {
            //// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            //// for form inputs)
            //if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
            //    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            //}
            //if (window.StatusBar) {
            //    // org.apache.cordova.statusbar required
            //    StatusBar.styleLightContent();
            //}
        });
    }
    config.$inject = ['$httpProvider', '$stateProvider', '$urlRouterProvider', '$ionicConfigProvider', 'smartBusinessConfig'];
    function config($httpProvider, $stateProvider, $urlRouterProvider, $ionicConfigProvider, smartBusinessConfig) {
        $ionicConfigProvider.tabs.style('standard');
        if (!$httpProvider.defaults.headers.common) {
            $httpProvider.defaults.headers.common = "";
        }
        $httpProvider.interceptors.push('authInterceptorFactory');
        $stateProvider.state('start', {
            url: '/start',
            templateUrl: 'templates/start.html',
            controller: 'startController',
            controllerAs: 'vm'
        }).state('startorder', {
            url: '/startorder',
            templateUrl: 'templates/startorder.html',
            controller: 'startOrderController',
            controllerAs: 'vm'
        }).state('sidemenu', {
            abstract: true,
            url: '/sidemenu',
            templateUrl: 'templates/sidemenu.html',
            controller: 'sideMenuController',
            controllerAs: 'vm'
        }).state('sidemenu.account', {
            url: '/account/:returnState',
            views: {
                'sidemenu-container': {
                    templateUrl: 'templates/account.html',
                    controller: 'accountController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.register', {
            url: '/register',
            views: {
                'sidemenu-container': {
                    templateUrl: 'templates/register.html',
                    controller: 'registerController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.about', {
            url: '/register',
            views: {
                'sidemenu-container': {
                    templateUrl: 'templates/about.html',
                    controller: 'aboutController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab', {
            url: "/tab",
            views: {
                'sidemenu-container': {
                    templateUrl: "templates/tabs.html",
                    controller: "tabController",
                    controllerAs: "vm"
                }
            }
        }).state('sidemenu.tab.home', {
            url: '/home',
            views: {
                'home-container': {
                    templateUrl: 'templates/tab-home.html',
                    controller: 'homeController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab.history', {
            url: "/history",
            views: {
                'history-container': {
                    templateUrl: "templates/history.html",
                    controller: "historyController",
                    controllerAs: "vm"
                }
            }
        }).state('sidemenu.tab.menu', {
            url: '/menu',
            views: {
                'menu-container': {
                    templateUrl: 'templates/tab-menu.html',
                    controller: 'categoryController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab.items', {
            url: '/items/:categoryId',
            views: {
                'menu-container': {
                    templateUrl: 'templates/tab-items.html',
                    controller: 'itemsController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab.item', {
            url: '/item/:itemId',
            views: {
                'menu-container': {
                    templateUrl: 'templates/tab-item.html',
                    controller: 'itemController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab.myorder', {
            url: '/myorder',
            views: {
                'myorder-container': {
                    templateUrl: 'templates/tab-myorder.html',
                    controller: 'myOrderController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab.orderitem', {
            url: '/orderitem/:orderItemId',
            views: {
                'myorder-container': {
                    templateUrl: 'templates/tab-orderItem.html',
                    controller: 'orderItemController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab.methods', {
            url: '/methods',
            views: {
                'myorder-container': {
                    templateUrl: 'templates/tab-methods.html',
                    controller: 'methodsController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab.time', {
            url: '/time',
            views: {
                'myorder-container': {
                    templateUrl: 'templates/tab-time.html',
                    controller: 'timeController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab.free', {
            url: '/free',
            views: {
                'myorder-container': {
                    templateUrl: 'templates/tab-free.html',
                    controller: 'freeController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab.stores', {
            url: '/stores',
            views: {
                'myorder-container': {
                    templateUrl: 'templates/tab-stores.html',
                    controller: 'storesController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab.paypal', {
            url: '/paypal',
            views: {
                'myorder-container': {
                    templateUrl: 'templates/tab-payment-paypal.html',
                    controller: 'paymentPaypalController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab.stripe', {
            url: '/stripe',
            views: {
                'myorder-container': {
                    templateUrl: 'templates/tab-payment-stripe.html',
                    controller: 'paymentStripeController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab.stripesca', {
            url: '/stripesca',
            views: {
                'myorder-container': {
                    templateUrl: 'templates/tab-payment-stripesca.html',
                    controller: 'paymentStripeSCAController',
                    controllerAs: 'vm'
                }
            }
        }).state('sidemenu.tab.braintree', {
            url: '/braintree',
            views: {
                'myorder-container': {
                    templateUrl: 'templates/tab-payment-braintree.html',
                    controller: 'paymentBraintreeController',
                    controllerAs: 'vm'
                }
            }
        });
        $urlRouterProvider.otherwise('/start');
    }
})();
var SmartBusiness;
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        AuthInterceptorFactory.$inject = ['$q', 'smartBusinessConfig', '$localstorage'];
        function AuthInterceptorFactory($q, config, localstorage) {
            return {
                request: function (config) {
                    config.headers = config.headers || {};
                    var authData = localstorage.getObject('authorizationData');
                    if (authData) {
                        config.headers.Authorization = 'Bearer ' + authData.token;
                    }
                    return config;
                },
                responseError: function (rejection) {
                    return $q.reject(rejection);
                }
            };
        }
        angular.module("smartBusiness").factory('authInterceptorFactory', AuthInterceptorFactory);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
/// <reference path="../../typings/frameworks/angular-local-storage.d.ts" />
var SmartBusiness;
/// <reference path="../../typings/frameworks/angular-local-storage.d.ts" />
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        var AuthService = (function () {
            function AuthService($http, $q, localstorage, smartBusinessConfig) {
                this.$http = $http;
                this.$q = $q;
                this.localstorage = localstorage;
                this.smartBusinessConfig = smartBusinessConfig;
            }
            AuthService.prototype.getToken = function () {
                var _this = this;
                this.localstorage.setObject("authorizationData", null);
                var data = "grant_type=password&username=&password=&appId=" + this.smartBusinessConfig.appId + "&apiKey=" + this.smartBusinessConfig.apiKey;
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/token', data, { headers: { 'Content-Type': 'application/x-www-form-urlencoded' } })
                    .success(function (response) {
                    var autho = { token: response.access_token };
                    _this.localstorage.setObject('authorizationData', autho);
                    deferred.resolve(response);
                }).error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            return AuthService;
        }());
        AuthService.$inject = ['$http', '$q', '$localstorage', 'smartBusinessConfig'];
        Services.AuthService = AuthService;
        angular.module("smartBusiness").service('authService', SmartBusiness.Services.AuthService);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        var BillboardService = (function () {
            function BillboardService($http, $q, smartBusinessConfig) {
                this.$http = $http;
                this.$q = $q;
                this.smartBusinessConfig = smartBusinessConfig;
            }
            BillboardService.prototype.list = function () {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/billboard/' + this.smartBusinessConfig.shopId + '/list').
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            return BillboardService;
        }());
        BillboardService.$inject = ['$http', '$q', 'smartBusinessConfig'];
        Services.BillboardService = BillboardService;
        angular.module("smartBusiness").service('billboardService', SmartBusiness.Services.BillboardService);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        var CategoryService = (function () {
            function CategoryService($http, $q, smartBusinessConfig) {
                this.$http = $http;
                this.$q = $q;
                this.smartBusinessConfig = smartBusinessConfig;
            }
            CategoryService.prototype.list = function () {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/shop/' + this.smartBusinessConfig.shopId + '/categories').
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            CategoryService.prototype.items = function (categoryId) {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/category/' + this.smartBusinessConfig.shopId + '/' + categoryId + '/items').
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            return CategoryService;
        }());
        CategoryService.$inject = ['$http', '$q', 'smartBusinessConfig'];
        Services.CategoryService = CategoryService;
        angular.module("smartBusiness").service('categoryService', SmartBusiness.Services.CategoryService);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        var CustomerService = (function () {
            function CustomerService($http, $q, smartBusinessConfig, $rootScope) {
                this.$http = $http;
                this.$q = $q;
                this.smartBusinessConfig = smartBusinessConfig;
                this.$rootScope = $rootScope;
            }
            CustomerService.prototype.login = function (user) {
                var _this = this;
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/customer/' + this.smartBusinessConfig.shopId + '/login', user).
                    success(function (response) {
                    deferred.resolve(response);
                    _this.$rootScope.$broadcast('CustomerLoggedIn', {});
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            CustomerService.prototype.signup = function (customer, orderId) {
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/customer/' + this.smartBusinessConfig.shopId + '/signup/' + orderId, customer).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            CustomerService.prototype.get = function (customerId) {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/customer/' + this.smartBusinessConfig.shopId + '/' + customerId).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            CustomerService.prototype.history = function (customerId, page) {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/customer/' + this.smartBusinessConfig.shopId + '/' + customerId + '/history/' + page).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            return CustomerService;
        }());
        CustomerService.$inject = ['$http', '$q', 'smartBusinessConfig', '$rootScope'];
        Services.CustomerService = CustomerService;
        angular.module("smartBusiness").service('customerService', SmartBusiness.Services.CustomerService);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        var ItemService = (function () {
            function ItemService($http, $q, smartBusinessConfig) {
                this.$http = $http;
                this.$q = $q;
                this.smartBusinessConfig = smartBusinessConfig;
            }
            ItemService.prototype.get = function (itemId) {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/item/' + this.smartBusinessConfig.shopId + '/' + itemId).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            ItemService.prototype.calculate = function (itemId, item) {
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/item/' + this.smartBusinessConfig.shopId + '/' + itemId + '/calculate', item).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            ItemService.prototype.localCalculator = function (item, quantity) {
                if (quantity === void 0) { quantity = 1; }
                var calculatedPrice = item.basePrice;
                angular.forEach(item.sections, function (section) {
                    if (section.sectionTypeId == SmartBusiness.Models.SectionTypeEnum.ForItems) {
                        if (!section.isMultiSelect) {
                            angular.forEach(section.options, function (option) {
                                if (option.optionId == section.selectedOptionId) {
                                    calculatedPrice += option.prices[0].price;
                                }
                            });
                        }
                        else {
                            var selectedOptions = 0;
                            angular.forEach(section.options, function (option) {
                                if (option.selected) {
                                    selectedOptions++;
                                }
                            });
                            angular.forEach(section.options, function (option) {
                                if (option.selected) {
                                    calculatedPrice += option.prices[0].price;
                                }
                                option.active = section.maximumOptions == null || option.selected || (selectedOptions < section.maximumOptions);
                            });
                        }
                    }
                    else {
                        if (!section.isMultiSelect) {
                            angular.forEach(section.options, function (option) {
                                var priceIsFound = false;
                                angular.forEach(option.prices, function (price) {
                                    if (!priceIsFound) {
                                        var relatedSection = null;
                                        angular.forEach(item.sections, function (sec) {
                                            if (relatedSection == null && sec.sectionId == price.sectionId) {
                                                relatedSection = sec;
                                            }
                                        });
                                        if (relatedSection != null) {
                                            if (price.optionId == relatedSection.selectedOptionId) {
                                                priceIsFound = true;
                                                option.price = price.price;
                                                option.priceDisplay = price.priceDisplay;
                                                if (option.optionId == section.selectedOptionId) {
                                                    calculatedPrice += price.price;
                                                }
                                            }
                                        }
                                    }
                                });
                            });
                        }
                        else {
                            var selectedOptions = 0;
                            angular.forEach(section.options, function (option) {
                                if (option.selected) {
                                    selectedOptions++;
                                }
                            });
                            angular.forEach(section.options, function (option) {
                                var priceIsFound = false;
                                angular.forEach(option.prices, function (price) {
                                    if (!priceIsFound) {
                                        var relatedSection = null;
                                        angular.forEach(item.sections, function (sec) {
                                            if (relatedSection == null && sec.sectionId == price.sectionId) {
                                                relatedSection = sec;
                                            }
                                        });
                                        if (relatedSection != null) {
                                            if (price.optionId == relatedSection.selectedOptionId) {
                                                priceIsFound = true;
                                                option.price = price.price;
                                                option.priceDisplay = price.priceDisplay;
                                                if (option.selected) {
                                                    calculatedPrice += price.price;
                                                }
                                            }
                                        }
                                    }
                                });
                                option.active = section.maximumOptions == null || option.selected || (selectedOptions < section.maximumOptions);
                            });
                        }
                    }
                });
                item.price = calculatedPrice * quantity;
                item.priceDisplay = item.pricePlaceHolder.replace("0.00", item.price.toFixed(2));
                return item;
            };
            return ItemService;
        }());
        ItemService.$inject = ['$http', '$q', 'smartBusinessConfig'];
        Services.ItemService = ItemService;
        angular.module("smartBusiness").service('itemService', SmartBusiness.Services.ItemService);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        var MessageService = (function () {
            function MessageService() {
            }
            MessageService.prototype.getMessage = function (messages) {
                var message = "";
                for (var i = 0; i < messages.length; i++)
                    message += messages[i] + "<br/>";
                return message;
            };
            return MessageService;
        }());
        MessageService.$inject = [];
        Services.MessageService = MessageService;
        angular.module("smartBusiness").service('messageService', SmartBusiness.Services.MessageService);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        var OrderItemService = (function () {
            function OrderItemService($http, $q, smartBusinessConfig) {
                this.$http = $http;
                this.$q = $q;
                this.smartBusinessConfig = smartBusinessConfig;
            }
            OrderItemService.prototype.get = function (orderItemId) {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/orderitem/' + this.smartBusinessConfig.shopId + '/' + orderItemId).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            return OrderItemService;
        }());
        OrderItemService.$inject = ['$http', '$q', 'smartBusinessConfig'];
        Services.OrderItemService = OrderItemService;
        angular.module("smartBusiness").service('orderItemService', SmartBusiness.Services.OrderItemService);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        var OrderService = (function () {
            function OrderService($http, $q, smartBusinessConfig, localstorage, $rootScope) {
                this.$http = $http;
                this.$q = $q;
                this.smartBusinessConfig = smartBusinessConfig;
                this.localstorage = localstorage;
                this.$rootScope = $rootScope;
            }
            OrderService.prototype.addItem = function (itemToAdd, orderId) {
                var _this = this;
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/add/' + orderId, itemToAdd).
                    success(function (response) {
                    deferred.resolve(response);
                    _this.localstorage.setObject("myOrder", null);
                    _this.$rootScope.$broadcast('OrderChanged', {
                        itemCount: response.value.itemCount
                    });
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.addFreeItem = function (itemToAdd, orderId) {
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/free/' + orderId, itemToAdd).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.updateItem = function (itemToUpdate, orderId) {
                var _this = this;
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/update/' + orderId, itemToUpdate).
                    success(function (response) {
                    deferred.resolve(response);
                    _this.localstorage.setObject("myOrder", null);
                    _this.$rootScope.$broadcast('OrderChanged', {
                        itemCount: response.value.itemCount
                    });
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.deleteItem = function (orderItemId, orderId) {
                var _this = this;
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/delete/' + orderId + '/' + orderItemId, {}).
                    success(function (response) {
                    deferred.resolve(response);
                    _this.localstorage.setObject("myOrder", null);
                    _this.$rootScope.$broadcast('OrderChanged', {
                        itemCount: response.value.itemCount
                    });
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.incrementItem = function (orderItemId, orderId) {
                var _this = this;
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/increment/' + orderId + '/' + orderItemId, {}).
                    success(function (response) {
                    deferred.resolve(response);
                    _this.localstorage.setObject("myOrder", null);
                    _this.$rootScope.$broadcast('OrderChanged', {
                        itemCount: response.value.itemCount
                    });
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.decrementItem = function (orderItemId, orderId) {
                var _this = this;
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/decrement/' + orderId + '/' + orderItemId, {}).
                    success(function (response) {
                    deferred.resolve(response);
                    _this.localstorage.setObject("myOrder", null);
                    _this.$rootScope.$broadcast('OrderChanged', {
                        itemCount: response.value.itemCount
                    });
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.reOrder = function (orderId) {
                var _this = this;
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/reorder/' + orderId, {}).
                    success(function (response) {
                    deferred.resolve(response);
                    _this.localstorage.setObject("myOrder", null);
                    _this.$rootScope.$broadcast('OrderChanged', {
                        itemCount: response.value.itemCount
                    });
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.order = function (orderId) {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/order/' + orderId).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.checkout = function (orderId) {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/checkout/' + orderId).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.times = function (orderId) {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/times/' + orderId).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.freeItems = function (orderId) {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/free/' + orderId).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.stores = function (orderId) {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/stores/' + orderId).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.updateCustomer = function (customerId, orderId) {
                var deferred = this.$q.defer();
                var data = {
                    customerId: customerId
                };
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/customer/' + orderId, data).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.updateDeliveryMethod = function (deliveryMethodId, orderId, customerId) {
                var deferred = this.$q.defer();
                var data = {
                    deliveryMethodId: deliveryMethodId,
                    customerId: customerId
                };
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/delivery/' + orderId, data).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.updateMethods = function (checkout, orderId) {
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/methods/' + orderId, checkout).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.updateTime = function (checkout, orderId) {
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/time/' + orderId, checkout).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.updateInstructions = function (checkout, orderId) {
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/instructions/' + orderId, checkout).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.updateStore = function (checkout, orderId) {
                var deferred = this.$q.defer();
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/store/' + orderId, checkout).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            OrderService.prototype.confirm = function (orderId) {
                var deferred = this.$q.defer();
                var data = {
                    platform: ionic.Platform.platform()
                };
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/order/' + this.smartBusinessConfig.shopId + '/confirm/' + orderId, data).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            return OrderService;
        }());
        OrderService.$inject = ['$http', '$q', 'smartBusinessConfig', '$localstorage', '$rootScope'];
        Services.OrderService = OrderService;
        angular.module("smartBusiness").service('orderService', SmartBusiness.Services.OrderService);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        var PaymentBraintreeService = (function () {
            function PaymentBraintreeService($http, $q, smartBusinessConfig) {
                this.$http = $http;
                this.$q = $q;
                this.smartBusinessConfig = smartBusinessConfig;
            }
            PaymentBraintreeService.prototype.pay = function (nonce, orderId) {
                var deferred = this.$q.defer();
                var data = {
                    nonce: nonce,
                    platform: ionic.Platform.platform()
                };
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/braintree/' + this.smartBusinessConfig.shopId + '/pay/' + orderId, data).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            return PaymentBraintreeService;
        }());
        PaymentBraintreeService.$inject = ['$http', '$q', 'smartBusinessConfig'];
        Services.PaymentBraintreeService = PaymentBraintreeService;
        angular.module("smartBusiness").service('paymentBraintreeService', SmartBusiness.Services.PaymentBraintreeService);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        var PaymentStripeService = (function () {
            function PaymentStripeService($http, $q, smartBusinessConfig) {
                this.$http = $http;
                this.$q = $q;
                this.smartBusinessConfig = smartBusinessConfig;
            }
            PaymentStripeService.prototype.pay = function (stripeToken, orderId) {
                var deferred = this.$q.defer();
                var data = {
                    stripeToken: stripeToken,
                    platform: ionic.Platform.platform()
                };
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/stripe/' + this.smartBusinessConfig.shopId + '/pay/' + orderId, data).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            PaymentStripeService.prototype.getIntent = function (orderId) {
                var deferred = this.$q.defer();
                var data = {
                    id: orderId,
                    platform: ionic.Platform.platform()
                };
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/stripesca/' + this.smartBusinessConfig.shopId + '/intent/' + orderId, data).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            PaymentStripeService.prototype.pay_sca = function (orderId, intentId) {
                var deferred = this.$q.defer();
                var data = {
                    id: orderId,
                    IntentId: intentId,
                    platform: ionic.Platform.platform()
                };
                this.$http.post(this.smartBusinessConfig.hostUrl + '/api/stripesca/' + this.smartBusinessConfig.shopId + '/pay/' + orderId, data).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            return PaymentStripeService;
        }());
        PaymentStripeService.$inject = ['$http', '$q', 'smartBusinessConfig'];
        Services.PaymentStripeService = PaymentStripeService;
        angular.module("smartBusiness").service('paymentStripeService', SmartBusiness.Services.PaymentStripeService);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        var PromotionService = (function () {
            function PromotionService($http, $q, smartBusinessConfig) {
                this.$http = $http;
                this.$q = $q;
                this.smartBusinessConfig = smartBusinessConfig;
            }
            PromotionService.prototype.list = function () {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/promotion/' + this.smartBusinessConfig.shopId + '/list').
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            return PromotionService;
        }());
        PromotionService.$inject = ['$http', '$q', 'smartBusinessConfig'];
        Services.PromotionService = PromotionService;
        angular.module("smartBusiness").service('promotionService', SmartBusiness.Services.PromotionService);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        var ShopService = (function () {
            function ShopService($http, $q, smartBusinessConfig) {
                this.$http = $http;
                this.$q = $q;
                this.smartBusinessConfig = smartBusinessConfig;
            }
            ShopService.prototype.get = function () {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/shop/' + this.smartBusinessConfig.shopId).
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            ShopService.prototype.tradingHours = function () {
                var deferred = this.$q.defer();
                this.$http.get(this.smartBusinessConfig.hostUrl + '/api/shop/' + this.smartBusinessConfig.shopId + '/tradinghours').
                    success(function (response) {
                    deferred.resolve(response);
                }).
                    error(function (err) {
                    deferred.reject(err);
                });
                return deferred.promise;
            };
            return ShopService;
        }());
        ShopService.$inject = ['$http', '$q', 'smartBusinessConfig'];
        Services.ShopService = ShopService;
        angular.module("smartBusiness").service('shopService', SmartBusiness.Services.ShopService);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Services;
    (function (Services) {
        'use strict';
        var StateService = (function () {
            function StateService(shopService, orderService, ionicLoading, localstorage, $ionicHistory, $ionicPopup, $state, $rootScope) {
                this.shopService = shopService;
                this.orderService = orderService;
                this.ionicLoading = ionicLoading;
                this.localstorage = localstorage;
                this.$ionicHistory = $ionicHistory;
                this.$ionicPopup = $ionicPopup;
                this.$state = $state;
                this.$rootScope = $rootScope;
            }
            StateService.prototype.selectFreeItems = function (orderId) {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.freeItems(orderId).then(function (result) {
                    if (result.length > 0) {
                        _this.$state.go('sidemenu.tab.free');
                    }
                    else {
                        _this.selectStore(orderId);
                    }
                }).catch(function () {
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            StateService.prototype.selectStore = function (orderId) {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                var shop = this.localstorage.getObject("shop");
                if (shop.stores.length > 1) {
                    this.$state.go('sidemenu.tab.stores');
                }
                else {
                    var checkout = {
                        storeId: shop.stores[0].storeId
                    };
                    this.orderService.updateStore(checkout, orderId).then(function (result) {
                        _this.$state.go('sidemenu.tab.methods');
                    }).catch(function () {
                    }).finally(function () {
                        _this.ionicLoading.hide();
                    });
                }
            };
            StateService.prototype.selectPayment = function (orderId) {
                var _this = this;
                this.shopService.get().then(function (result) {
                    _this.localstorage.setObject("shop", result);
                    var me = _this;
                    _this.ionicLoading.show({
                        templateUrl: 'templates/loading.html'
                    });
                    var shop = _this.localstorage.getObject("shop");
                    var selectedPaymentMethodId = _this.localstorage.getObject("selectedPaymentMethodId");
                    if (selectedPaymentMethodId == SmartBusiness.Models.PaymentMethodEnum.Cash) {
                        _this.orderService.confirm(orderId).then(function (result) {
                            if (result.isSuccess) {
                                _this.selectConfirm(result.value);
                            }
                            else {
                                _this.ionicLoading.hide();
                                var message = "Something went wrong. Please try again later.";
                                if (result.value == -1) {
                                    _this.localstorage.setObject("customer", null);
                                    message = "Please login to continue.";
                                }
                                var alertPopup = _this.$ionicPopup.alert({
                                    title: 'Error',
                                    template: result.messages[0],
                                    okType: 'button-stable'
                                });
                                alertPopup.then(function (res) {
                                    if (result.value == -1) {
                                        me.$state.go('sidemenu.account');
                                    }
                                });
                            }
                        }).catch(function () {
                        }).finally(function () {
                            _this.ionicLoading.hide();
                        });
                    }
                    else {
                        switch (shop.appPaymentTypeId) {
                            case SmartBusiness.Models.PaymentTypeEnum.Paypal:
                                _this.$state.go('sidemenu.tab.paypal');
                                break;
                            case SmartBusiness.Models.PaymentTypeEnum.Braintree:
                                _this.$state.go('sidemenu.tab.braintree');
                                break;
                            case SmartBusiness.Models.PaymentTypeEnum.Stripe:
                                _this.$state.go('sidemenu.tab.stripe');
                                break;
                            case SmartBusiness.Models.PaymentTypeEnum.StripeSCA:
                                _this.$state.go('sidemenu.tab.stripesca');
                                break;
                        }
                    }
                });
            };
            StateService.prototype.selectConfirm = function (orderNo) {
                var _this = this;
                this.$rootScope.$broadcast('OrderChanged', {
                    itemCount: 0
                });
                this.localstorage.setObject("myOrder", null);
                this.localstorage.set("orderId", "");
                this.localstorage.setObject("selectedPaymentMethodId", 0);
                this.$ionicHistory.clearCache();
                this.$ionicHistory.clearHistory();
                this.$ionicHistory.nextViewOptions({ historyRoot: true });
                this.$state.go('sidemenu.tab.myorder').then(function () {
                    _this.$state.go('sidemenu.tab.home');
                });
                this.ionicLoading.hide();
                var alertPopup = this.$ionicPopup.alert({
                    title: 'Confirm',
                    template: "Your order has been confirmed.<br/><br/>Order No: " + orderNo,
                    okType: 'button-stable'
                });
                alertPopup.then(function (res) { });
            };
            return StateService;
        }());
        StateService.$inject = ['shopService', 'orderService', '$ionicLoading', '$localstorage', '$ionicHistory', '$ionicPopup', '$state', '$rootScope'];
        Services.StateService = StateService;
        angular.module("smartBusiness").service('stateService', SmartBusiness.Services.StateService);
    })(Services = SmartBusiness.Services || (SmartBusiness.Services = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var AboutController = (function () {
            function AboutController(shopService, localstorage) {
                var _this = this;
                this.shopService = shopService;
                this.localstorage = localstorage;
                this.shop = this.localstorage.getObject("shop");
                this.shopService.tradingHours().then(function (result) {
                    _this.tradingHours = result;
                    _this.displayStores();
                });
            }
            AboutController.prototype.displayStores = function () {
                var _this = this;
                var center = new google.maps.LatLng(this.shop.stores[0].latitude, this.shop.stores[0].longitude);
                var customer = this.localstorage.getObject("customer");
                if (customer != null && customer.isGeocoded) {
                    var center = new google.maps.LatLng(customer.latitude, customer.longitude);
                }
                var mapOptions = {
                    center: center,
                    zoom: 9,
                    mapTypeId: google.maps.MapTypeId.ROADMAP
                };
                this.map = new google.maps.Map(document.getElementById("map"), mapOptions);
                var markers = new Array();
                google.maps.event.addListenerOnce(this.map, 'idle', function () {
                    angular.forEach(_this.shop.stores, function (store) {
                        var marker = new google.maps.Marker({
                            map: _this.map,
                            animation: google.maps.Animation.DROP,
                            position: new google.maps.LatLng(store.latitude, store.longitude)
                        });
                        var infoWindow = new google.maps.InfoWindow({
                            content: store.storeTitle
                        });
                        google.maps.event.addListener(marker, 'click', function () {
                            infoWindow.open(_this.map, marker);
                        });
                        markers.push(marker);
                    });
                    if (customer != null && customer.isGeocoded) {
                        var marker = new google.maps.Marker({
                            map: _this.map,
                            animation: google.maps.Animation.BOUNCE,
                            position: new google.maps.LatLng(customer.latitude, customer.longitude)
                        });
                        var infoWindow = new google.maps.InfoWindow({
                            content: customer.fullname
                        });
                        google.maps.event.addListener(marker, 'click', function () {
                            infoWindow.open(_this.map, marker);
                        });
                        markers.push(marker);
                    }
                    var bounds = new google.maps.LatLngBounds();
                    for (var i = 0; i < markers.length; i++) {
                        bounds.extend(markers[i].getPosition());
                    }
                    _this.map.fitBounds(bounds);
                });
            };
            return AboutController;
        }());
        AboutController.$inject = ['shopService', '$localstorage'];
        Controllers.AboutController = AboutController;
        angular.module("smartBusiness").controller("aboutController", SmartBusiness.Controllers.AboutController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var AccountController = (function () {
            function AccountController(customerService, orderService, ionicLoading, ionicPopup, state, $stateParams, messageService, localstorage, $rootScope) {
                this.customerService = customerService;
                this.orderService = orderService;
                this.ionicLoading = ionicLoading;
                this.ionicPopup = ionicPopup;
                this.state = state;
                this.$stateParams = $stateParams;
                this.messageService = messageService;
                this.localstorage = localstorage;
                this.$rootScope = $rootScope;
                this.customer = this.localstorage.getObject("customer");
                this.returnState = this.$stateParams.returnState;
            }
            AccountController.prototype.login = function () {
                var _this = this;
                var messages = this.validate(this.user);
                if (messages.length > 0) {
                    this.ionicPopup.alert({
                        title: 'Login failed!',
                        template: this.messageService.getMessage(messages),
                        okType: 'button-stable'
                    });
                }
                else {
                    this.ionicLoading.show({
                        templateUrl: 'templates/loading.html'
                    });
                    this.customerService.login(this.user).then(function (result) {
                        _this.user = null;
                        _this.customer = result;
                        _this.localstorage.setObject("customer", result);
                        var orderId = _this.localstorage.get("orderId");
                        if (orderId != null) {
                            _this.orderService.updateCustomer(_this.customer.customerId, orderId).then(function (result) {
                                _this.ionicLoading.hide();
                                if (_this.returnState == null)
                                    _this.state.go('sidemenu.tab.home');
                                else
                                    _this.state.go(_this.returnState);
                            });
                        }
                        else {
                            _this.ionicLoading.hide();
                            if (_this.returnState == null)
                                _this.state.go('sidemenu.tab.home');
                            else
                                _this.state.go(_this.returnState);
                        }
                    }).catch(function () {
                        _this.ionicLoading.hide();
                        _this.ionicPopup.alert({
                            title: 'Login failed!',
                            template: 'Please check your credentials!',
                            okType: 'button-stable'
                        });
                    });
                }
            };
            AccountController.prototype.validate = function (user) {
                var messages = new Array();
                if (this.user == null) {
                    messages.push("Please enter all fields");
                }
                else {
                    if (this.user.username == null) {
                        messages.push("Please enter a valid email");
                    }
                    if (this.user.password == null) {
                        messages.push("Please enter your password");
                    }
                }
                return messages;
            };
            AccountController.prototype.logout = function () {
                this.customer = null;
                this.localstorage.setObject("customer", null);
                this.$rootScope.$broadcast('CustomerLoggedOut', {});
            };
            return AccountController;
        }());
        AccountController.$inject = ['customerService', 'orderService', '$ionicLoading', '$ionicPopup', '$state', '$stateParams', 'messageService', '$localstorage', '$rootScope'];
        Controllers.AccountController = AccountController;
        angular.module("smartBusiness").controller("accountController", SmartBusiness.Controllers.AccountController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var CategoryController = (function () {
            function CategoryController(categoryService, ionicLoading, smartBusinessConfig, localstorage, $state) {
                this.categoryService = categoryService;
                this.ionicLoading = ionicLoading;
                this.smartBusinessConfig = smartBusinessConfig;
                this.localstorage = localstorage;
                this.$state = $state;
                this.hostUrl = smartBusinessConfig.hostUrl;
                this.shop = this.localstorage.getObject("shop");
                if (this.shop.bannerUrl != null) {
                    this.bannerUrl = this.smartBusinessConfig.hostUrl + this.shop.bannerUrl;
                }
                this.list();
            }
            CategoryController.prototype.list = function () {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.categoryService.list().then(function (result) {
                    _this.categories = result;
                    _this.splitedCategories = Array();
                    var subCategory = Array();
                    for (var i = 0; i < _this.categories.length; i++) {
                        subCategory.push(_this.categories[i]);
                        if ((i + 1) % 2 == 0) {
                            _this.splitedCategories.push(subCategory);
                            subCategory = Array();
                        }
                        else if (i == _this.categories.length - 1) {
                            subCategory.push({ isFake: true });
                            _this.splitedCategories.push(subCategory);
                        }
                    }
                    _this.ionicLoading.hide();
                });
            };
            CategoryController.prototype.showItems = function (categoryId) {
                this.$state.go('sidemenu.tab.items', { categoryId: categoryId });
            };
            return CategoryController;
        }());
        CategoryController.$inject = ['categoryService', '$ionicLoading', 'smartBusinessConfig', '$localstorage', '$state'];
        Controllers.CategoryController = CategoryController;
        angular.module("smartBusiness").controller("categoryController", SmartBusiness.Controllers.CategoryController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var FreeController = (function () {
            function FreeController(orderService, stateService, ionicLoading, localstorage, $state) {
                this.orderService = orderService;
                this.stateService = stateService;
                this.ionicLoading = ionicLoading;
                this.localstorage = localstorage;
                this.$state = $state;
                this.orderId = this.localstorage.get("orderId");
                this.orderId = this.orderId != null ? this.orderId : "";
                this.get(this.orderId);
            }
            FreeController.prototype.get = function (orderId) {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.freeItems(orderId).then(function (result) {
                    if (result.length > 0) {
                        _this.items = result;
                    }
                    else {
                        _this.stateService.selectStore(orderId);
                    }
                }).catch(function () {
                    _this.items = null;
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            FreeController.prototype.updateSelection = function (index) {
                angular.forEach(this.items, function (item, i) {
                    if (i != index)
                        item.selected = false;
                });
            };
            FreeController.prototype.save = function () {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                var selectedItem;
                angular.forEach(this.items, function (item) {
                    if (item.selected) {
                        selectedItem = item;
                    }
                });
                var itemToAdd = {
                    item: selectedItem
                };
                this.orderService.addFreeItem(itemToAdd, this.orderId).then(function (result) {
                    _this.stateService.selectStore(_this.orderId);
                });
            };
            return FreeController;
        }());
        FreeController.$inject = ['orderService', 'stateService', '$ionicLoading', '$localstorage', '$state'];
        Controllers.FreeController = FreeController;
        angular.module("smartBusiness").controller("freeController", SmartBusiness.Controllers.FreeController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var HistoryController = (function () {
            function HistoryController(customerService, orderService, $state, ionicLoading, localstorage, $rootScope, $timeout, state) {
                this.customerService = customerService;
                this.orderService = orderService;
                this.$state = $state;
                this.ionicLoading = ionicLoading;
                this.localstorage = localstorage;
                this.$rootScope = $rootScope;
                this.$timeout = $timeout;
                this.state = state;
                this.customer = this.localstorage.getObject("customer");
                this.shop = this.localstorage.getObject("shop");
                if (this.customer != null) {
                    this.page = 1;
                    this.orders = [];
                    this.getHistory();
                }
                else {
                    this.state.go('sidemenu.account', { returnState: 'sidemenu.tab.history' });
                }
            }
            HistoryController.prototype.getHistory = function () {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.customerService.history(this.customer.customerId, this.page).then(function (result) {
                    angular.forEach(result.orders, function (order) {
                        _this.orders.push(order);
                    });
                    _this.hasNextPage = result.hasNextPage;
                    if (result.hasNextPage) {
                        _this.page++;
                    }
                    _this.ionicLoading.hide();
                });
            };
            HistoryController.prototype.toggleOrder = function (order) {
                if (this.isOrderShown(order)) {
                    this.shownOrder = null;
                }
                else {
                    this.shownOrder = order;
                }
            };
            HistoryController.prototype.isOrderShown = function (order) {
                return this.shownOrder === order;
            };
            HistoryController.prototype.reOrder = function (order) {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.reOrder(order.guid).then(function (result) {
                    _this.localstorage.set("orderId", result.value.guid);
                    _this.ionicLoading.hide();
                    _this.$timeout(function () {
                        _this.$rootScope.$broadcast('OrderChanged', {
                            itemCount: result.value.itemCount
                        });
                    });
                    _this.$state.go('sidemenu.tab.myorder');
                });
            };
            return HistoryController;
        }());
        HistoryController.$inject = ['customerService', 'orderService', '$state', '$ionicLoading', '$localstorage', '$rootScope', '$timeout', '$state'];
        Controllers.HistoryController = HistoryController;
        angular.module("smartBusiness").controller("historyController", SmartBusiness.Controllers.HistoryController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var HomeController = (function () {
            function HomeController(shopService, promotionService, billboardService, ionicLoading, localstorage, smartBusinessConfig /*,
                private $scope: any*/) {
                this.shopService = shopService;
                this.promotionService = promotionService;
                this.billboardService = billboardService;
                this.ionicLoading = ionicLoading;
                this.localstorage = localstorage;
                this.smartBusinessConfig = smartBusinessConfig; /*,
                private $scope: any*/
                this.customer = this.localstorage.getObject("customer");
                this.shop = this.localstorage.getObject("shop");
                if (this.shop.bannerUrl != null) {
                    this.bannerUrl = this.smartBusinessConfig.hostUrl + this.shop.bannerUrl;
                }
                //var me = this;
                //$scope.$on('$ionicView.loaded', function () {
                //    me.listPromotions();
                //});
                //this.listPromotions();
                this.listBillboard();
            }
            HomeController.prototype.listPromotions = function () {
                var _this = this;
                this.promotionService.list().then(function (result) {
                    _this.promotions = result;
                });
            };
            HomeController.prototype.listBillboard = function () {
                var _this = this;
                this.billboardService.list().then(function (result) {
                    _this.billboards = result;
                });
            };
            return HomeController;
        }());
        HomeController.$inject = ['shopService', 'promotionService', 'billboardService', '$ionicLoading', '$localstorage', 'smartBusinessConfig' /*, '$scope'*/];
        Controllers.HomeController = HomeController;
        angular.module("smartBusiness").controller("homeController", SmartBusiness.Controllers.HomeController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var ItemController = (function () {
            function ItemController(itemService, orderService, ionicLoading, ionicHistory, localstorage, $stateParams, $ionicPopup, smartBusinessConfig) {
                this.itemService = itemService;
                this.orderService = orderService;
                this.ionicLoading = ionicLoading;
                this.ionicHistory = ionicHistory;
                this.localstorage = localstorage;
                this.$stateParams = $stateParams;
                this.$ionicPopup = $ionicPopup;
                this.smartBusinessConfig = smartBusinessConfig;
                var shop = this.localstorage.getObject("shop");
                this.hostUrl = this.smartBusinessConfig.hostUrl;
                this.shopIsOpen = shop.isOpen;
                this.quantity = 1;
                this.itemId = $stateParams.itemId;
                this.details();
            }
            ItemController.prototype.details = function () {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.itemService.get(this.itemId).then(function (result) {
                    _this.item = result;
                    _this.claculate();
                });
            };
            ItemController.prototype.addToOrder = function () {
                var _this = this;
                var customer = this.localstorage.getObject("customer");
                var customerId = null;
                if (customer != null && customer != undefined) {
                    customerId = customer.customerId;
                }
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                var itemToAdd = {
                    item: this.item,
                    quantity: this.quantity,
                    customerId: customerId
                };
                var orderId = this.localstorage.get("orderId");
                orderId = orderId != null ? orderId : "";
                this.orderService.addItem(itemToAdd, orderId).then(function (result) {
                    _this.localstorage.set("orderId", result.value.guid);
                    _this.ionicLoading.hide();
                    _this.ionicHistory.goBack();
                }).catch(function (reason) {
                    _this.ionicLoading.hide();
                    var alertPopup = _this.$ionicPopup.alert({
                        title: 'Error',
                        template: "Something went wrong. Please try again",
                        okType: 'button-stable'
                    });
                });
            };
            ItemController.prototype.claculate = function () {
                this.item = this.itemService.localCalculator(this.item, this.quantity);
                this.ionicLoading.hide();
            };
            ItemController.prototype.radioClick = function (event, section) {
                if (!section.selectFirstItem) {
                    if (event.target.value == section.lastSelectedOptionId) {
                        section.selectedOptionId = 0;
                        section.lastSelectedOptionId = 0;
                    }
                    else {
                        section.lastSelectedOptionId = event.target.value;
                    }
                }
                this.claculate();
            };
            ItemController.prototype.increment = function () {
                this.quantity++;
                this.claculate();
            };
            ItemController.prototype.decrement = function () {
                if (this.quantity > 1) {
                    this.quantity--;
                    this.claculate();
                }
            };
            ItemController.prototype.toggleSection = function (section) {
                if (this.isSectionShown(section)) {
                    this.shownSection = null;
                }
                else {
                    this.shownSection = section;
                }
            };
            ItemController.prototype.isSectionShown = function (section) {
                return this.shownSection === section;
            };
            return ItemController;
        }());
        ItemController.$inject = ['itemService', 'orderService', '$ionicLoading', '$ionicHistory', '$localstorage', '$stateParams', '$ionicPopup', 'smartBusinessConfig'];
        Controllers.ItemController = ItemController;
        angular.module("smartBusiness").controller("itemController", SmartBusiness.Controllers.ItemController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var ItemsController = (function () {
            function ItemsController(categoryService, ionicLoading, $stateParams) {
                this.categoryService = categoryService;
                this.ionicLoading = ionicLoading;
                this.categoryId = $stateParams.categoryId;
                this.list();
            }
            ItemsController.prototype.list = function () {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.categoryService.items(this.categoryId).then(function (result) {
                    _this.category = result;
                    _this.ionicLoading.hide();
                });
            };
            return ItemsController;
        }());
        ItemsController.$inject = ['categoryService', '$ionicLoading', '$stateParams'];
        Controllers.ItemsController = ItemsController;
        angular.module("smartBusiness").controller("itemsController", SmartBusiness.Controllers.ItemsController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var MethodsController = (function () {
            function MethodsController(orderService, ionicLoading, localstorage, $state) {
                this.orderService = orderService;
                this.ionicLoading = ionicLoading;
                this.localstorage = localstorage;
                this.$state = $state;
                this.saving = false;
                var orderId = this.localstorage.get("orderId");
                orderId = orderId != null ? orderId : "";
                this.shop = this.localstorage.getObject("shop");
                this.get(orderId);
            }
            MethodsController.prototype.get = function (orderId) {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.checkout(orderId).then(function (result) {
                    _this.checkout = result;
                }).catch(function () {
                    _this.checkout = null;
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            MethodsController.prototype.saveMethods = function () {
                var _this = this;
                this.saving = true;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                var orderId = this.localstorage.get("orderId");
                orderId = orderId != null ? orderId : "";
                this.orderService.updateMethods(this.checkout, orderId).then(function (result) {
                    _this.localstorage.setObject("selectedPaymentMethodId", _this.checkout.paymentMethodId);
                    _this.ionicLoading.hide();
                    _this.$state.go('sidemenu.tab.time');
                }).catch(function () {
                    _this.saving = false;
                }).finally(function () {
                });
            };
            return MethodsController;
        }());
        MethodsController.$inject = ['orderService', '$ionicLoading', '$localstorage', '$state'];
        Controllers.MethodsController = MethodsController;
        angular.module("smartBusiness").controller("methodsController", SmartBusiness.Controllers.MethodsController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var MyOrderController = (function () {
            function MyOrderController(orderService, ionicLoading, ionicHistory, localstorage, stateService, state) {
                this.orderService = orderService;
                this.ionicLoading = ionicLoading;
                this.ionicHistory = ionicHistory;
                this.localstorage = localstorage;
                this.stateService = stateService;
                this.state = state;
                var orderId = this.localstorage.get("orderId");
                orderId = orderId != null ? orderId : "";
                this.order = this.localstorage.getObject("myOrder");
                if (this.order == null)
                    this.get(orderId);
            }
            MyOrderController.prototype.get = function (orderId) {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.order(orderId).then(function (result) {
                    _this.order = result;
                    _this.localstorage.setObject("myOrder", result);
                }).catch(function () {
                    _this.order = null;
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            MyOrderController.prototype.edit = function (orderItemId) {
                this.state.go('sidemenu.tab.orderitem', { orderItemId: orderItemId });
            };
            MyOrderController.prototype.delete = function (orderItemId) {
                var _this = this;
                var orderId = this.localstorage.get("orderId");
                orderId = orderId != null ? orderId : "";
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.deleteItem(orderItemId, orderId).then(function (result) {
                    if (result.isSuccess) {
                        _this.get(orderId);
                    }
                }).catch(function () {
                }).finally(function () {
                    // this.ionicLoading.hide();
                });
            };
            MyOrderController.prototype.increment = function (orderItemId) {
                var _this = this;
                var orderId = this.localstorage.get("orderId");
                orderId = orderId != null ? orderId : "";
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.incrementItem(orderItemId, orderId).then(function (result) {
                    if (result.isSuccess) {
                        _this.get(orderId);
                    }
                }).catch(function () {
                });
            };
            MyOrderController.prototype.decrement = function (orderItemId) {
                var _this = this;
                var orderId = this.localstorage.get("orderId");
                orderId = orderId != null ? orderId : "";
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.decrementItem(orderItemId, orderId).then(function (result) {
                    if (result.isSuccess) {
                        _this.get(orderId);
                    }
                }).catch(function () {
                });
            };
            MyOrderController.prototype.stores = function () {
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                var orderId = this.localstorage.get("orderId");
                orderId = orderId != null ? orderId : "";
                var customer = this.localstorage.getObject("customer");
                if (customer == null) {
                    this.ionicLoading.hide();
                    this.state.go('sidemenu.account', { returnState: 'sidemenu.tab.myorder' });
                }
                else {
                    this.stateService.selectFreeItems(orderId);
                }
            };
            return MyOrderController;
        }());
        MyOrderController.$inject = ['orderService', '$ionicLoading', '$ionicHistory', '$localstorage', 'stateService', '$state'];
        Controllers.MyOrderController = MyOrderController;
        angular.module("smartBusiness").controller("myOrderController", SmartBusiness.Controllers.MyOrderController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var OrderItemController = (function () {
            function OrderItemController(itemService, orderService, orderItemService, ionicLoading, ionicHistory, localstorage, $state, $stateParams, $ionicPopup, smartBusinessConfig) {
                this.itemService = itemService;
                this.orderService = orderService;
                this.orderItemService = orderItemService;
                this.ionicLoading = ionicLoading;
                this.ionicHistory = ionicHistory;
                this.localstorage = localstorage;
                this.$state = $state;
                this.$stateParams = $stateParams;
                this.$ionicPopup = $ionicPopup;
                this.smartBusinessConfig = smartBusinessConfig;
                this.hostUrl = this.smartBusinessConfig.hostUrl;
                this.orderItemId = $stateParams.orderItemId;
                this.details();
            }
            OrderItemController.prototype.details = function () {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderItemService.get(this.orderItemId).then(function (result) {
                    _this.item = result.item;
                    _this.quantity = result.quantity;
                    _this.claculate();
                });
            };
            OrderItemController.prototype.update = function () {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                var itemToUpdate = {
                    orderItemId: this.orderItemId,
                    item: this.item,
                    quantity: this.quantity
                };
                var orderId = this.localstorage.get("orderId");
                orderId = orderId != null ? orderId : "";
                this.orderService.updateItem(itemToUpdate, orderId).then(function (result) {
                    _this.ionicLoading.hide();
                    _this.$state.go('sidemenu.tab.myorder');
                }).catch(function (reason) {
                    _this.ionicLoading.hide();
                    var alertPopup = _this.$ionicPopup.alert({
                        title: 'Error',
                        template: "Something went wrong. Please try again",
                        okType: 'button-stable'
                    });
                });
            };
            OrderItemController.prototype.claculate = function () {
                this.item = this.itemService.localCalculator(this.item, this.quantity);
                this.ionicLoading.hide();
            };
            OrderItemController.prototype.radioClick = function (event, section) {
                if (!section.selectFirstItem) {
                    if (event.target.value == section.lastSelectedOptionId) {
                        section.selectedOptionId = 0;
                        section.lastSelectedOptionId = 0;
                    }
                    else {
                        section.lastSelectedOptionId = event.target.value;
                    }
                }
                this.claculate();
            };
            OrderItemController.prototype.increment = function () {
                this.quantity++;
                this.claculate();
            };
            OrderItemController.prototype.decrement = function () {
                if (this.quantity > 1) {
                    this.quantity--;
                    this.claculate();
                }
            };
            return OrderItemController;
        }());
        OrderItemController.$inject = ['itemService', 'orderService', 'orderItemService', '$ionicLoading', '$ionicHistory', '$localstorage', '$state', '$stateParams', '$ionicPopup', 'smartBusinessConfig'];
        Controllers.OrderItemController = OrderItemController;
        angular.module("smartBusiness").controller("orderItemController", SmartBusiness.Controllers.OrderItemController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var PaymentBraintreeController = (function () {
            function PaymentBraintreeController(orderService, paymentBraintreeService, messageService, stateService, ionicLoading, ionicPopup, localstorage, $timeout) {
                this.orderService = orderService;
                this.paymentBraintreeService = paymentBraintreeService;
                this.messageService = messageService;
                this.stateService = stateService;
                this.ionicLoading = ionicLoading;
                this.ionicPopup = ionicPopup;
                this.localstorage = localstorage;
                this.$timeout = $timeout;
                this.orderId = this.localstorage.get("orderId");
                this.orderId = this.orderId != null ? this.orderId : "";
                this.disablePay = true;
                this.get(this.orderId);
            }
            PaymentBraintreeController.prototype.get = function (orderId) {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.order(orderId).then(function (result) {
                    _this.order = result;
                    var shop = _this.localstorage.getObject("shop");
                    braintree.setup(shop.braintreeClientToken, 'dropin', {
                        container: 'payment-form',
                        onPaymentMethodReceived: function (data) { return _this.pay(data.nonce); },
                        onReady: function () {
                            _this.$timeout(function () {
                                _this.disablePay = false;
                            }, 0);
                        },
                        onError: function (err) {
                            _this.disablePay = false;
                            var alertPopup = _this.ionicPopup.alert({
                                title: 'Error!',
                                template: err.message,
                                okType: 'button-stable'
                            });
                        }
                    });
                }).catch(function () {
                    _this.order = null;
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            PaymentBraintreeController.prototype.pay = function (nonce) {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.paymentBraintreeService.pay(nonce, this.orderId).then(function (result) {
                    if (result.isSuccess) {
                        _this.stateService.selectConfirm(result.value);
                    }
                    else {
                        var alertPopup = _this.ionicPopup.alert({
                            title: 'Error!',
                            template: _this.messageService.getMessage(result.messages)
                        });
                    }
                }).catch(function () {
                    var alertPopup = _this.ionicPopup.alert({
                        title: 'Error!',
                        template: "Something went wrong, please try again"
                    });
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            return PaymentBraintreeController;
        }());
        PaymentBraintreeController.$inject = ['orderService', 'paymentBraintreeService', 'messageService', 'stateService', '$ionicLoading', '$ionicPopup', '$localstorage', '$timeout'];
        Controllers.PaymentBraintreeController = PaymentBraintreeController;
        angular.module("smartBusiness").controller("paymentBraintreeController", SmartBusiness.Controllers.PaymentBraintreeController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var PaymentStripeController = (function () {
            function PaymentStripeController(orderService, paymentStripeService, messageService, stateService, ionicLoading, ionicPopup, localstorage) {
                this.orderService = orderService;
                this.paymentStripeService = paymentStripeService;
                this.messageService = messageService;
                this.stateService = stateService;
                this.ionicLoading = ionicLoading;
                this.ionicPopup = ionicPopup;
                this.localstorage = localstorage;
                this.orderId = this.localstorage.get("orderId");
                this.orderId = this.orderId != null ? this.orderId : "";
                this.get(this.orderId);
            }
            PaymentStripeController.prototype.get = function (orderId) {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.order(orderId).then(function (result) {
                    _this.order = result;
                }).catch(function () {
                    _this.order = null;
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            PaymentStripeController.prototype.formIsNotComplete = function () {
                return (this.cardNumber == null ||
                    this.expiryDate == null ||
                    this.cvc == null ||
                    this.postCode == null ||
                    this.cardNumber == "" ||
                    this.expiryDate == "" ||
                    this.cvc == "" ||
                    this.postCode == "");
            };
            PaymentStripeController.prototype.validate = function () {
                var messages = new Array();
                if (!Stripe.card.validateCardNumber(this.cardNumber)) {
                    messages.push("The credit card number appears to be invalid.");
                }
                this.month = this.expiryDate.substring(0, 2);
                this.year = this.expiryDate.substring(2, 4);
                if (!Stripe.card.validateExpiry(this.month, this.year)) {
                    messages.push("The expiry date appears to be invalid.");
                }
                if (!Stripe.card.validateCVC(this.cvc)) {
                    messages.push("The CVC number appears to be invalid.");
                }
                if (!this.postCode) {
                    messages.push("The post code appears to be invalid.");
                }
                return messages;
            };
            PaymentStripeController.prototype.pay = function () {
                var _this = this;
                var messages = this.validate();
                if (messages.length > 0) {
                    var alertPopup = this.ionicPopup.alert({
                        title: 'Error!',
                        template: this.messageService.getMessage(messages)
                    });
                }
                else {
                    this.ionicLoading.show({
                        templateUrl: 'templates/loading.html'
                    });
                    var shop = this.localstorage.getObject("shop");
                    Stripe.setPublishableKey(shop.stripePublishableKey);
                    Stripe.card.createToken({
                        number: this.cardNumber,
                        cvc: this.cvc,
                        exp_month: this.month,
                        exp_year: this.year,
                        address_zip: this.postCode
                    }, function (status, response) {
                        if (response.error) {
                            var errors = new Array();
                            errors.push(response.error.message);
                            var alertPopup = _this.ionicPopup.alert({
                                title: 'Error!',
                                template: _this.messageService.getMessage(errors)
                            });
                        }
                        else {
                            _this.paymentStripeService.pay(response.id, _this.orderId).then(function (result) {
                                if (result.isSuccess) {
                                    _this.stateService.selectConfirm(result.value);
                                }
                                else {
                                    var alertPopup = _this.ionicPopup.alert({
                                        title: 'Error!',
                                        template: _this.messageService.getMessage(result.messages)
                                    });
                                }
                            }).catch(function () {
                                var alertPopup = _this.ionicPopup.alert({
                                    title: 'Error!',
                                    template: "Something went wrong, please try again"
                                });
                            }).finally(function () {
                                _this.ionicLoading.hide();
                            });
                        }
                    });
                }
            };
            return PaymentStripeController;
        }());
        PaymentStripeController.$inject = ['orderService', 'paymentStripeService', 'messageService', 'stateService', '$ionicLoading', '$ionicPopup', '$localstorage'];
        Controllers.PaymentStripeController = PaymentStripeController;
        angular.module("smartBusiness").controller("paymentStripeController", SmartBusiness.Controllers.PaymentStripeController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var PaymentStripeSCAController = (function () {
            function PaymentStripeSCAController($timeout, orderService, paymentStripeService, messageService, stateService, ionicLoading, ionicPopup, localstorage) {
                this.$timeout = $timeout;
                this.orderService = orderService;
                this.paymentStripeService = paymentStripeService;
                this.messageService = messageService;
                this.stateService = stateService;
                this.ionicLoading = ionicLoading;
                this.ionicPopup = ionicPopup;
                this.localstorage = localstorage;
                this.postCodeErrorMessages = "";
                this.isProcessing = false;
                this.orderId = this.localstorage.get("orderId");
                this.customer = this.localstorage.getObject("customer");
                this.orderId = this.orderId != null ? this.orderId : "";
                var shop = this.localstorage.getObject("shop");
                this.stripe = Stripe(shop.stripePublishableKey);
                this.getStripeIntent();
                this.get(this.orderId);
            }
            PaymentStripeSCAController.prototype.handlePostCodeValidation = function () {
                var self = this;
                var isValid = this.validatePostCode(this.postCode);
                var message = "";
                if (isValid == false) {
                    message = 'Postcode is invalid.';
                }
                else {
                    message = "";
                }
                self.$timeout(function () {
                    self.postCodeErrorMessages = message;
                }, 0);
                return isValid;
            };
            PaymentStripeSCAController.prototype.validatePostCode = function (v) {
                if (v == null || v == undefined) {
                    return false;
                }
                if (v.trim().length !== 0) {
                    var re = /^(([gG][iI][rR] {0,}0[aA]{2})|(([aA][sS][cC][nN]|[sS][tT][hH][lL]|[tT][dD][cC][uU]|[bB][bB][nN][dD]|[bB][iI][qQ][qQ]|[fF][iI][qQ][qQ]|[pP][cC][rR][nN]|[sS][iI][qQ][qQ]|[iT][kK][cC][aA]) {0,}1[zZ]{2})|((([a-pr-uwyzA-PR-UWYZ][a-hk-yxA-HK-XY]?[0-9][0-9]?)|(([a-pr-uwyzA-PR-UWYZ][0-9][a-hjkstuwA-HJKSTUW])|([a-pr-uwyzA-PR-UWYZ][a-hk-yA-HK-Y][0-9][abehmnprv-yABEHMNPRV-Y]))) {0,}[0-9][abd-hjlnp-uw-zABD-HJLNP-UW-Z]{2}))$/;
                    if (!re.test(v)) {
                        return false;
                    }
                    return true;
                }
                return false;
            };
            PaymentStripeSCAController.prototype.getStripeIntent = function () {
                var _this = this;
                var self = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.paymentStripeService.getIntent(this.orderId).then(function (result) {
                    self.clientSecret = result['clientSecret'];
                    self.intentId = result['intentId'];
                    self.initStripeElement(self.stripe);
                }).catch(function () {
                    _this.order = null;
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            PaymentStripeSCAController.prototype.initStripeElement = function (stripe) {
                var elements = stripe.elements();
                var elementStyles = {
                    base: {
                        color: '#32325D',
                        fontWeight: 500,
                        fontFamily: 'Source Code Pro, Consolas, Menlo, monospace',
                        fontSize: '16px',
                        fontSmoothing: 'antialiased',
                        '::placeholder': {
                            color: '#CFD7DF',
                        },
                        ':-webkit-autofill': {
                            color: '#e39f48',
                        },
                    },
                    invalid: {
                        color: '#E25950',
                        '::placeholder': {
                            color: '#FFCCA5',
                        },
                    },
                };
                var elementClasses = {
                    focus: 'focused',
                    empty: 'empty',
                    invalid: 'invalid',
                };
                var cardNumber = elements.create('cardNumber', {
                    style: elementStyles,
                    classes: elementClasses,
                });
                cardNumber.mount('#example2-card-number');
                var cardExpiry = elements.create('cardExpiry', {
                    style: elementStyles,
                    classes: elementClasses,
                });
                cardExpiry.mount('#example2-card-expiry');
                var cardCvc = elements.create('cardCvc', {
                    style: elementStyles,
                    classes: elementClasses,
                });
                cardCvc.mount('#example2-card-cvc');
                this.card_details = [cardNumber, cardExpiry, cardCvc];
                this.registerElements(this.card_details);
                //handleFormSubmit(stripe, card_details, clientSecret, intentId);
            };
            PaymentStripeSCAController.prototype.registerElements = function (card_details) {
                var self = this;
                self.errorMessages = "";
                self.stripeProcessErrorMessages = "";
                // Listen for errors from each Element, and show error messages in the UI.
                var savedErrors = {};
                card_details.forEach(function (element, idx) {
                    element.on('change', function (event) {
                        if (event.error) {
                            savedErrors[idx] = event.error.message;
                            self.errorMessages = event.error.message;
                            self.$timeout(function () {
                                self.stripeProcessErrorMessages = "";
                                self.errorMessages = self.errorMessages + "";
                            }, 0);
                        }
                        else {
                            savedErrors[idx] = null;
                            // Loop over the saved errors and find the first one, if any.
                            var nextError = Object.keys(savedErrors)
                                .sort()
                                .reduce(function (maybeFoundError, key) {
                                return maybeFoundError || savedErrors[key];
                            }, null);
                            if (nextError) {
                                // Now that they've fixed the current error, show another one.
                                self.errorMessages = nextError;
                                self.$timeout(function () {
                                    self.stripeProcessErrorMessages = "";
                                    self.errorMessages = self.errorMessages + "";
                                }, 0);
                            }
                            else {
                                // The user fixed the last error; no more errors.
                                self.errorMessages = "";
                                self.$timeout(function () {
                                    self.stripeProcessErrorMessages = "";
                                    self.errorMessages = self.errorMessages + "";
                                }, 0);
                            }
                        }
                    });
                });
            };
            PaymentStripeSCAController.prototype.stripeTokenHandler = function (token) {
                var _this = this;
                // Insert the token ID into the form so it gets submitted to the server
                var form = document.getElementById('payment-form');
                var hiddenInput = document.createElement('input');
                hiddenInput.setAttribute('type', 'hidden');
                hiddenInput.setAttribute('name', 'stripeToken');
                hiddenInput.setAttribute('value', token.id);
                form.appendChild(hiddenInput);
                // Submit the form
                //form['submit']();
                this.paymentStripeService.pay(token.id, this.orderId).then(function (result) {
                    if (result.isSuccess) {
                        _this.stateService.selectConfirm(result.value);
                    }
                    else {
                        var alertPopup = _this.ionicPopup.alert({
                            title: 'Error!',
                            template: _this.messageService.getMessage(result.messages)
                        });
                    }
                }).catch(function () {
                    var alertPopup = _this.ionicPopup.alert({
                        title: 'Error!',
                        template: "Something went wrong, please try again"
                    });
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            PaymentStripeSCAController.prototype.createToken = function () {
                var self = this;
                if (self.called == true) {
                    return;
                }
                self.called = true;
                this.stripe.createToken(this.card).then(function (result) {
                    if (result.error) {
                        // Inform the user if there was an error
                        var errorElement = document.getElementById('card-errors');
                        errorElement.textContent = result.error.message;
                    }
                    else {
                        // Send the token to your server
                        self.stripeTokenHandler(result.token);
                    }
                });
            };
            ;
            PaymentStripeSCAController.prototype.get = function (orderId) {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.order(orderId).then(function (result) {
                    _this.order = result;
                }).catch(function () {
                    _this.order = null;
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            PaymentStripeSCAController.prototype.formIsNotComplete = function () {
                return (this.postCodeErrorMessages != "" ||
                    this.errorMessages != "");
            };
            PaymentStripeSCAController.prototype.pay = function (ev) {
                var _this = this;
                var self = this;
                self.stripeProcessErrorMessages = "";
                if (self.handlePostCodeValidation() == false) {
                    ev.preventDefault();
                    return false;
                }
                self.$timeout(function () { self.isProcessing = true; }, 0);
                self.card_details[0].update({ disabled: true });
                self.card_details[1].update({ disabled: true });
                self.card_details[2].update({ disabled: true });
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                self.stripe.confirmCardPayment(self.clientSecret, {
                    payment_method: {
                        card: self.card_details[0],
                        billing_details: {
                            name: self.customer['Name'] + self.customer['Family'],
                            email: self.customer['Email'],
                            address: {
                                city: '',
                                country: 'GB',
                                line1: '',
                                line2: '',
                                postal_code: self.postCode,
                            }
                        }
                    }
                }).then(function (result) {
                    if (result.error) {
                        self.card_details[0].update({ disabled: false });
                        self.card_details[1].update({ disabled: false });
                        self.card_details[2].update({ disabled: false });
                        self.$timeout(function () { self.isProcessing = false; }, 0);
                        self.ionicLoading.hide();
                        // Show error to your customer (e.g., insufficient funds)
                        self.stripeProcessErrorMessages = "Can not process your card: " + result.error.message;
                    }
                    else {
                        // The payment has been processed!
                        if (result.paymentIntent.status === 'succeeded') {
                            debugger;
                            //self.ionicLoading.hide();
                            // self.ionicLoading.show({
                            //     templateUrl: 'templates/loading.html'
                            // });
                            self.paymentStripeService.pay_sca(self.orderId, self.intentId).then(function (result) {
                                if (result.isSuccess) {
                                    self.errorMessages = "";
                                    self.ionicLoading.hide();
                                    self.stateService.selectConfirm(result.value);
                                }
                                else {
                                    self.$timeout(function () { self.isProcessing = false; }, 0);
                                    self.ionicLoading.hide();
                                    var alertPopup = self.ionicPopup.alert({
                                        title: 'Error!',
                                        template: self.messageService.getMessage(result.messages)
                                    });
                                }
                            }).catch(function () {
                                self.$timeout(function () { self.isProcessing = false; }, 0);
                                self.ionicLoading.hide();
                                self.stripeProcessErrorMessages = "Something went wrong, please try again";
                                var alertPopup = self.ionicPopup.alert({
                                    title: 'Error!',
                                    template: "Something went wrong, please try again"
                                });
                            }).finally(function () {
                            });
                        }
                    }
                }).catch(function () {
                    _this.ionicLoading.hide();
                    self.$timeout(function () { self.isProcessing = false; }, 0);
                    self.stripeProcessErrorMessages = "Something went wrong, please try again";
                    var alertPopup = _this.ionicPopup.alert({
                        title: 'Error!',
                        template: "Something went wrong, please try again"
                    });
                }).finally(function () {
                });
                ;
            };
            return PaymentStripeSCAController;
        }());
        PaymentStripeSCAController.$inject = ['$timeout', 'orderService', 'paymentStripeService', 'messageService', 'stateService', '$ionicLoading', '$ionicPopup', '$localstorage'];
        Controllers.PaymentStripeSCAController = PaymentStripeSCAController;
        angular.module("smartBusiness").controller("paymentStripeSCAController", SmartBusiness.Controllers.PaymentStripeSCAController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var RegisterController = (function () {
            function RegisterController(customerService, ionicLoading, ionicPopup, localstorage, messageService, $ionicHistory, state) {
                this.customerService = customerService;
                this.ionicLoading = ionicLoading;
                this.ionicPopup = ionicPopup;
                this.localstorage = localstorage;
                this.messageService = messageService;
                this.$ionicHistory = $ionicHistory;
                this.state = state;
                this.customer = null;
            }
            RegisterController.prototype.signup = function () {
                var _this = this;
                var messages = this.validate(this.customer);
                if (messages.length > 0) {
                    this.ionicPopup.alert({
                        title: 'Register failed!',
                        template: this.messageService.getMessage(messages),
                        okType: 'button-stable'
                    });
                }
                else {
                    this.ionicLoading.show({
                        templateUrl: 'templates/loading.html'
                    });
                    var orderId = this.localstorage.get("orderId");
                    orderId = orderId != null ? orderId : "";
                    this.customerService.signup(this.customer, orderId).then(function (result) {
                        _this.ionicLoading.hide();
                        if (result.isSuccess) {
                            _this.localstorage.setObject("customer", result.value);
                            _this.$ionicHistory.clearHistory();
                            _this.state.go('sidemenu.tab.home', {}, { reload: true });
                        }
                        else {
                            _this.ionicPopup.alert({
                                title: 'Register failed!',
                                template: _this.messageService.getMessage(result.messages),
                                okType: 'button-stable'
                            });
                        }
                    }).catch(function (e) {
                        _this.ionicLoading.hide();
                        _this.ionicPopup.alert({
                            title: 'Register failed!',
                            template: "Something went wrong. Try again please.",
                            okType: 'button-stable'
                        });
                    });
                }
            };
            RegisterController.prototype.validate = function (user) {
                var messages = new Array();
                if (this.customer == null) {
                    messages.push("Please enter all fields");
                }
                else {
                    if (this.customer.name == null) {
                        messages.push("Please enter your name");
                    }
                    if (this.customer.family == null) {
                        messages.push("Please enter your family");
                    }
                    if (this.customer.unit == null) {
                        messages.push("Please enter House/Flat No.");
                    }
                    if (this.customer.streetName == null) {
                        messages.push("Please enter steet name");
                    }
                    if (this.customer.suburb == null) {
                        messages.push("Please enter suburb");
                    }
                    if (this.customer.postCode == null) {
                        messages.push("Please enter a valid post code");
                    }
                    if (this.customer.mobile == null) {
                        messages.push("Please enter a valid mobile");
                    }
                    if (this.customer.email == null) {
                        messages.push("Please enter a valid email");
                    }
                    if (this.customer.password == null) {
                        messages.push("Please enter your password");
                    }
                }
                return messages;
            };
            return RegisterController;
        }());
        RegisterController.$inject = ['customerService', '$ionicLoading', '$ionicPopup', '$localstorage', 'messageService', '$ionicHistory', '$state'];
        Controllers.RegisterController = RegisterController;
        angular.module("smartBusiness").controller("registerController", SmartBusiness.Controllers.RegisterController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var SideMenuController = (function () {
            function SideMenuController(localstorage, $scope) {
                //var customer = this.localstorage.getObject("customer");
                //this.customerHasLoggedIn = (customer != null);
                this.localstorage = localstorage;
                //$scope.$on('CustomerLoggedIn', (event, data) => {
                //    this.customerHasLoggedIn = true;
                //});
                //$scope.$on('CustomerLoggedOut', (event, data) => {
                //    this.customerHasLoggedIn = false;
                //});
            }
            return SideMenuController;
        }());
        //customerHasLoggedIn: boolean;
        SideMenuController.$inject = ['$localstorage', '$scope'];
        Controllers.SideMenuController = SideMenuController;
        angular.module("smartBusiness").controller("sideMenuController", SmartBusiness.Controllers.SideMenuController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var StartController = (function () {
            function StartController(shopService, customerService, authService, localstorage, ionicLoading, $ionicPopup, smartBusinessConfig) {
                this.shopService = shopService;
                this.customerService = customerService;
                this.authService = authService;
                this.localstorage = localstorage;
                this.ionicLoading = ionicLoading;
                this.$ionicPopup = $ionicPopup;
                this.smartBusinessConfig = smartBusinessConfig;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.auth();
            }
            StartController.prototype.auth = function () {
                var _this = this;
                this.authService.getToken().then(function () {
                    _this.init();
                }).catch(function (reason) {
                    _this.ionicLoading.hide();
                    var messgae = 'Something went wrong. Please try again later.';
                    if (reason != null) {
                        messgae = reason.error_description;
                    }
                    var alertPopup = _this.$ionicPopup.alert({
                        title: 'System Message',
                        template: messgae,
                        okType: 'button-stable'
                    });
                    alertPopup.then(function (res) {
                        ionic.Platform.exitApp();
                    });
                });
            };
            StartController.prototype.init = function () {
                var _this = this;
                this.shopService.get().then(function (result) {
                    if (!result.isUnderMaintenance) {
                        _this.localstorage.setObject("shop", result);
                        _this.localstorage.set("orderId", "");
                        _this.localstorage.setObject("myOrder", null);
                        _this.shop = result;
                        _this.logoUrl = _this.smartBusinessConfig.hostUrl + result.logoUrl;
                        if (result.bannerUrl != null) {
                            _this.bannerUrl = _this.smartBusinessConfig.hostUrl + result.bannerUrl;
                        }
                        var customer = _this.localstorage.getObject("customer");
                        if (customer != null) {
                            _this.customerService.get(customer.customerId).then(function (result) {
                                if (result != null) {
                                    _this.localstorage.setObject("customer", result);
                                }
                            }).catch(function (e) {
                                _this.localstorage.setObject("customer", null);
                            }).finally(function () {
                                _this.ionicLoading.hide();
                            });
                        }
                        else
                            _this.ionicLoading.hide();
                    }
                    else {
                        _this.ionicLoading.hide();
                        var alertPopup = _this.$ionicPopup.alert({
                            title: 'Under Maintenance',
                            template: "We are performing some maintenance at the moment. Please try again later.",
                            okType: 'button-stable'
                        });
                        alertPopup.then(function (res) {
                            ionic.Platform.exitApp();
                        });
                    }
                });
            };
            return StartController;
        }());
        StartController.$inject = ['shopService', 'customerService', 'authService', '$localstorage', '$ionicLoading', '$ionicPopup', 'smartBusinessConfig'];
        Controllers.StartController = StartController;
        angular.module("smartBusiness").controller("startController", SmartBusiness.Controllers.StartController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var StartOrderController = (function () {
            function StartOrderController(orderService, ionicLoading, $state, localstorage) {
                this.orderService = orderService;
                this.ionicLoading = ionicLoading;
                this.$state = $state;
                this.localstorage = localstorage;
                var orderId = this.localstorage.get("orderId");
                orderId = orderId != null ? orderId : "";
                this.get(orderId);
            }
            StartOrderController.prototype.get = function (orderId) {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.checkout(orderId).then(function (result) {
                    _this.checkout = result;
                    _this.localstorage.set("orderId", _this.checkout.orderGuid);
                }).catch(function () {
                    _this.checkout = null;
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            StartOrderController.prototype.saveDeliveryMethod = function () {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                var orderId = this.localstorage.get("orderId");
                orderId = orderId != null ? orderId : "";
                var customer = this.localstorage.getObject("customer");
                var customerId = null;
                if (customer != null) {
                    customerId = customer.customerId;
                }
                this.orderService.updateDeliveryMethod(this.checkout.deliveryMethodId, orderId, customerId).then(function (result) {
                    _this.ionicLoading.hide();
                    _this.$state.go('sidemenu.tab.home');
                }).catch(function () {
                }).finally(function () {
                });
            };
            return StartOrderController;
        }());
        StartOrderController.$inject = ['orderService', '$ionicLoading', '$state', '$localstorage'];
        Controllers.StartOrderController = StartOrderController;
        angular.module("smartBusiness").controller("startOrderController", SmartBusiness.Controllers.StartOrderController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var StoresController = (function () {
            function StoresController(orderService, stateService, ionicLoading, localstorage, $state) {
                this.orderService = orderService;
                this.stateService = stateService;
                this.ionicLoading = ionicLoading;
                this.localstorage = localstorage;
                this.$state = $state;
                var orderId = this.localstorage.get("orderId");
                orderId = orderId != null ? orderId : "";
                this.get(orderId);
            }
            StoresController.prototype.get = function (orderId) {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.stores(orderId).then(function (result) {
                    _this.stores = result;
                    if (result.length > 0) {
                        _this.selectedStoreId = result[0].storeId;
                    }
                }).catch(function () {
                    _this.stores = null;
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            StoresController.prototype.saveStore = function () {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                var orderId = this.localstorage.get("orderId");
                orderId = orderId != null ? orderId : "";
                var checkout = {
                    storeId: this.selectedStoreId
                };
                this.orderService.updateStore(checkout, orderId).then(function (result) {
                    _this.$state.go('sidemenu.tab.methods');
                }).catch(function () {
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            return StoresController;
        }());
        StoresController.$inject = ['orderService', 'stateService', '$ionicLoading', '$localstorage', '$state'];
        Controllers.StoresController = StoresController;
        angular.module("smartBusiness").controller("storesController", SmartBusiness.Controllers.StoresController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var TabController = (function () {
            function TabController($scope, localstorage) {
                this.$scope = $scope;
                this.localstorage = localstorage;
                this.customer = this.localstorage.getObject("customer");
                $scope.$on('OrderChanged', function (event, data) {
                    $scope.itemCount = data.itemCount;
                });
            }
            TabController.prototype.logout = function () {
                this.customer = null;
                this.localstorage.setObject("customer", null);
            };
            return TabController;
        }());
        TabController.$inject = ['$scope', '$localstorage'];
        Controllers.TabController = TabController;
        angular.module("smartBusiness").controller("tabController", SmartBusiness.Controllers.TabController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Controllers;
    (function (Controllers) {
        var TimeController = (function () {
            function TimeController(orderService, stateService, ionicLoading, localstorage, $state, $ionicPopup, ionicTimePicker) {
                this.orderService = orderService;
                this.stateService = stateService;
                this.ionicLoading = ionicLoading;
                this.localstorage = localstorage;
                this.$state = $state;
                this.$ionicPopup = $ionicPopup;
                this.ionicTimePicker = ionicTimePicker;
                this.saving = false;
                this.orderId = this.localstorage.get("orderId");
                this.orderId = this.orderId != null ? this.orderId : "";
                this.selectedTime = "ASAP";
                this.otherTime = "";
                this.get(this.orderId);
            }
            TimeController.prototype.canContinue = function () {
                return (this.selectedTime != 'Other') || (this.selectedTime == 'Other' && (this.otherTime != '' && this.otherTime != null));
            };
            TimeController.prototype.get = function (orderId) {
                var _this = this;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                this.orderService.times(orderId).then(function (result) {
                    _this.minTime = result[0];
                    _this.maxTime = result[result.length - 1];
                }).catch(function () {
                    _this.minTime = null;
                }).finally(function () {
                    _this.ionicLoading.hide();
                });
            };
            TimeController.prototype.customTime = function () {
                var _this = this;
                var take = this.minTime.split(':');
                var seconds = parseFloat(take[0]) * 3600 + (parseFloat(take[1]) + 15) * 60;
                var timepickerSettings = {
                    callback: function (val) {
                        if (typeof (val) === 'undefined') {
                            var alertPopup = _this.$ionicPopup.alert({
                                title: 'Error',
                                template: 'Selected time should be after' + _this.minTime + ' and before ' + _this.maxTime,
                                okType: 'button-stable'
                            });
                        }
                        else {
                            var selectedTime = new Date(val * 1000);
                            var time = '';
                            var hours = selectedTime.getUTCHours();
                            var mins = selectedTime.getUTCMinutes();
                            time = (hours < 10) ? ('0' + hours.toString()) : hours.toString();
                            time += ':' + ((mins < 10) ? ('0' + mins.toString()) : mins.toString());
                            if (time < _this.minTime && time > _this.maxTime) {
                                var alertPopup = _this.$ionicPopup.alert({
                                    title: 'Error',
                                    template: 'Selected time should be after' + _this.minTime + ' and before ' + _this.maxTime,
                                    okType: 'button-stable'
                                });
                            }
                            else {
                                _this.otherTime = time;
                            }
                        }
                    },
                    inputTime: seconds,
                    format: 24,
                    step: 5
                };
                this.ionicTimePicker.openTimePicker(timepickerSettings);
            };
            TimeController.prototype.saveTime = function () {
                var _this = this;
                this.saving = true;
                this.ionicLoading.show({
                    templateUrl: 'templates/loading.html'
                });
                var time = this.selectedTime;
                var timeType = 1;
                if (time == 'Other') {
                    time = this.otherTime;
                    timeType = 3;
                }
                else if (time.trim() != 'ASAP') {
                    timeType = 2;
                }
                var checkout = {
                    time: time,
                    timeType: timeType,
                    instructions: this.instructions
                };
                this.orderService.updateTime(checkout, this.orderId).then(function (result) {
                    _this.stateService.selectPayment(_this.orderId);
                }).catch(function () {
                    _this.saving = false;
                    _this.ionicLoading.hide();
                }).finally(function () {
                });
            };
            return TimeController;
        }());
        TimeController.$inject = ['orderService', 'stateService', '$ionicLoading', '$localstorage', '$state', '$ionicPopup', 'ionicTimePicker'];
        Controllers.TimeController = TimeController;
        angular.module("smartBusiness").controller("timeController", SmartBusiness.Controllers.TimeController);
    })(Controllers = SmartBusiness.Controllers || (SmartBusiness.Controllers = {}));
})(SmartBusiness || (SmartBusiness = {}));
var SmartBusiness;
(function (SmartBusiness) {
    var Models;
    (function (Models) {
        var PaymentMethodEnum;
        (function (PaymentMethodEnum) {
            PaymentMethodEnum[PaymentMethodEnum["Cash"] = 1] = "Cash";
            PaymentMethodEnum[PaymentMethodEnum["Online"] = 2] = "Online";
        })(PaymentMethodEnum = Models.PaymentMethodEnum || (Models.PaymentMethodEnum = {}));
        var PaymentTypeEnum;
        (function (PaymentTypeEnum) {
            PaymentTypeEnum[PaymentTypeEnum["NoEftPos"] = 1] = "NoEftPos";
            PaymentTypeEnum[PaymentTypeEnum["Paypal"] = 2] = "Paypal";
            PaymentTypeEnum[PaymentTypeEnum["Braintree"] = 3] = "Braintree";
            PaymentTypeEnum[PaymentTypeEnum["Stripe"] = 4] = "Stripe";
            PaymentTypeEnum[PaymentTypeEnum["StripeSCA"] = 7] = "StripeSCA";
        })(PaymentTypeEnum = Models.PaymentTypeEnum || (Models.PaymentTypeEnum = {}));
        var SectionTypeEnum;
        (function (SectionTypeEnum) {
            SectionTypeEnum[SectionTypeEnum["ForItems"] = 1] = "ForItems";
            SectionTypeEnum[SectionTypeEnum["ForOptions"] = 2] = "ForOptions";
        })(SectionTypeEnum = Models.SectionTypeEnum || (Models.SectionTypeEnum = {}));
    })(Models = SmartBusiness.Models || (SmartBusiness.Models = {}));
})(SmartBusiness || (SmartBusiness = {}));
